blob: 1bbe55429df5e9ac3b8390a33671b22a459df069 [file] [log] [blame]
Yegor Timoshenkoc2e49412018-10-07 01:58:27 +00001#!/usr/bin/env bash
Martin Rothbec11082015-11-03 21:01:53 -07002#
Patrick Georgi7333a112020-05-08 20:48:04 +02003# SPDX-License-Identifier: GPL-2.0-only
Martin Rothbec11082015-11-03 21:01:53 -07004
Martin Rothfb190ed2016-10-01 20:13:43 -06005# This script creates a list of commits between two releases, broken out into
6# fairly inexact categories, based on the directories that files are in. If
7# a commit touched anything in the path that is checked earlier, it's counted
8# as being in that category.
9#
10# Don't run this in your current working tree, it checks out different versions
11# and can lose things.
Martin Rothbec11082015-11-03 21:01:53 -070012
Martin Rothfb190ed2016-10-01 20:13:43 -060013# set -x # uncomment for debug
14
15# Check for tools
16
Patrick Georgifa13a642018-12-20 17:17:03 +010017if ! ( git --version && cloc --version && rename --version ) > /dev/null 2>&1
Martin Rothfb190ed2016-10-01 20:13:43 -060018then
Martin Rotheb80d8d2022-02-28 14:41:57 -070019 echo "ERROR: cloc, git or rename is not installed. Exiting" >&2
Martin Rothbec11082015-11-03 21:01:53 -070020 exit 1
21fi
22
Alex Thiessenda384dd2018-01-13 16:31:28 +000023if ! { cdup="$(git rev-parse --show-cdup 2>/dev/null)" && [ -z "${cdup}" ]; }
24then
Martin Rotheb80d8d2022-02-28 14:41:57 -070025 echo "ERROR: This is not the top directory of a git repo. Exiting." >&2
Martin Rothfb190ed2016-10-01 20:13:43 -060026 exit 1
27fi
28
29# Try to verify that the repo is clean before losing state.
Martin Rotheb80d8d2022-02-28 14:41:57 -070030if ! git diff-index --quiet --cached HEAD 2>/dev/null || \
31 [ "$(git diff origin/master --shortstat 2>/dev/null | tail -n1)" != "" ]; then
32 echo "ERROR: repo is not clean. Exiting." >&2
Martin Rothbec11082015-11-03 21:01:53 -070033 exit 1
34fi
35
Martin Rothfb190ed2016-10-01 20:13:43 -060036# Verify the command line arguments
37if [ "$1" == "--help" ] || [ -z "$1" ] || [ -z "$2" ]; then
38 echo
39 echo "Usage: $0 <old_version> <new_version> [release notes file]"
40 echo "Old version should be a tag (4.1), a branch (origin/4.1), or a commit id"
Martin Rotheb80d8d2022-02-28 14:41:57 -070041 echo "New version can be a branch (origin/master) a tag (4.2), or a commit id"
Martin Rothfb190ed2016-10-01 20:13:43 -060042 echo "Logfile can be a new file or an existing file to update"
43 echo "Example: \"$0 origin/4.1 4.2 rnotes.txt\""
44 echo
45 echo "Note that the script starts at the commit AFTER the old version."
46 echo
47 exit 1
48else
49 OLD_GIT_VERSION="$1"
50 NEW_GIT_VERSION="$2"
Martin Rotheb80d8d2022-02-28 14:41:57 -070051 if [[ "$OLD_GIT_VERSION" = "HEAD" || "$NEW_GIT_VERSION" = "HEAD" ]]; then
52 echo "Error: using HEAD as a reference doesn't work" >&2
Patrick Georgi81a30ec2020-05-11 23:47:12 +020053 echo
54 exit 1
55 fi
Martin Rothfb190ed2016-10-01 20:13:43 -060056 TOTAL_COMMITS=$(git log --pretty=oneline \
57 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | wc -l)
58fi
59
60TOP=$(pwd)
61
62if [ -n "$3" ]; then
63 MAIN_LOGFILE="${TOP}/$3"
64else
65 MAIN_LOGFILE="${TOP}/relnotes.txt"
66fi
67
68# Figure out which logfile we're writing to. If the specified logfile exists,
69# we need to write to a temporary logfile, then append changes to the main
70# logfile.
Martin Rothbec11082015-11-03 21:01:53 -070071if [ -f "$MAIN_LOGFILE" ]; then
72 LOGFILE="$(mktemp "LOGFILE.XXXX")"
73 LOGFILE="${TOP}/$LOGFILE"
74 UPDATE_MAIN_LOGFILE=1
75else
76 LOGFILE="$MAIN_LOGFILE"
77fi
78
Martin Rothfb190ed2016-10-01 20:13:43 -060079get_author_commit_count() {
80 git log "${NEW_GIT_VERSION}" 2>/dev/null | grep -c "^Author: $1"
81}
82
83# Print and log the versions
Martin Rothbec11082015-11-03 21:01:53 -070084log_versions() {
85 echo "Log of commit $1 to commit $2"
86 echo "Log of commit $1 to commit $2" >> "$LOGFILE"
Martin Rothfb190ed2016-10-01 20:13:43 -060087 echo "Total commits: ${TOTAL_COMMITS}"
88 echo "Total commits: ${TOTAL_COMMITS}" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -070089 echo
90}
91
Martin Rothfb190ed2016-10-01 20:13:43 -060092# Get the first commit id in the current tree
Martin Rothbec11082015-11-03 21:01:53 -070093get_latest_commit_id() {
Martin Roth3ce67832017-11-04 18:36:19 -060094(
Martin Rotheb80d8d2022-02-28 14:41:57 -070095 cd "$1" || exit 1
96 git log -n 1 2>/dev/null | grep '^commit ' | head -1 | sed 's/commit //' | sed 's/ .*//'
Martin Roth3ce67832017-11-04 18:36:19 -060097)
Martin Rothbec11082015-11-03 21:01:53 -070098}
99
Martin Rothfb190ed2016-10-01 20:13:43 -0600100# Main get log function
Martin Rothbec11082015-11-03 21:01:53 -0700101_get_log() {
102 local oldver="$1"
103 local newver="$2"
104 local title="$3"
105 local paths="$4"
Martin Roth3ce67832017-11-04 18:36:19 -0600106 local keywords="$5"
Martin Rothbec11082015-11-03 21:01:53 -0700107
Martin Roth3ce67832017-11-04 18:36:19 -0600108 # Leave ${paths} unquoted in the git commands
Martin Rothfb190ed2016-10-01 20:13:43 -0600109 # shellcheck disable=SC2086
Martin Roth3ce67832017-11-04 18:36:19 -0600110 { \
111 if [ -n "$paths" ]; then \
112 git log --abbrev-commit --pretty=oneline \
113 "${oldver}..${newver}" -- ${paths} \
114 2>/dev/null; \
115 fi; \
116 if [ -n "$keywords" ]; then \
117 git log --abbrev-commit --pretty=oneline \
118 "${oldver}..${newver}" 2>/dev/null \
119 | grep -i "$keywords"; \
120 fi \
121 } | sort -t ' ' -k 2 | uniq
Martin Rothbec11082015-11-03 21:01:53 -0700122}
123
Martin Rothfb190ed2016-10-01 20:13:43 -0600124# Output to a new log, then compare to the first logfile, and only output
125# non duplicated lines to the final file.
Martin Rothbec11082015-11-03 21:01:53 -0700126get_log_dedupe() {
127 local title="$1"
128 local paths="$2"
Martin Roth3ce67832017-11-04 18:36:19 -0600129 local keywords="$3"
Martin Rothfb190ed2016-10-01 20:13:43 -0600130 local log
131 local commits
132
Martin Rothbec11082015-11-03 21:01:53 -0700133 dedupe_tmpfile="$(mktemp "LOGFILE.XXXX")"
134
Martin Rothfb190ed2016-10-01 20:13:43 -0600135 log=$(_get_log "$OLD_GIT_VERSION" "$NEW_GIT_VERSION" \
Martin Roth3ce67832017-11-04 18:36:19 -0600136 "$title" "$paths" "$keywords")
Martin Rothbec11082015-11-03 21:01:53 -0700137
138 echo "$log" > "$dedupe_tmpfile"
139
140 log=$(grep -Fxv -f "$LOGFILE" "$dedupe_tmpfile")
Martin Rothfb190ed2016-10-01 20:13:43 -0600141 commits=$(echo "$log" | wc -l)
Martin Rothbec11082015-11-03 21:01:53 -0700142
Martin Rotheb80d8d2022-02-28 14:41:57 -0700143 if [ -n "$log" ]; then
144 #echo "$title: $paths $keywords" >> "$LOGFILE"
145 printf "%s\n%s\n\n" "##### $title ($commits commits) #####" \
146 "$log" >> "$LOGFILE"
147 fi
Martin Rothbec11082015-11-03 21:01:53 -0700148
149 rm "$dedupe_tmpfile"
150}
151
152# get logs for the submodules
153get_log_submodule() {
154 local old_version="$1"
155 local new_version="$2"
156 local submodule_dir="$3"
Martin Rothfb190ed2016-10-01 20:13:43 -0600157 local log
158 local commits
Martin Rothbec11082015-11-03 21:01:53 -0700159
160 printf "Submodule %s\n" "$submodule_dir"
161 printf "commit %s to commit %s\n\n" "$old_version" "$new_version"
162
Martin Rotheb80d8d2022-02-28 14:41:57 -0700163 if ! (
164 cd "${TOP}/$submodule_dir" || exit 1
165 log="$(_get_log "$old_version" "$new_version" "$submodule_dir" "." "")" || exit 1
Martin Rothfb190ed2016-10-01 20:13:43 -0600166 commits=$(echo "$log" | wc -l)
Martin Rothbec11082015-11-03 21:01:53 -0700167
168 if [ -n "$log" ]; then
Martin Roth3ce67832017-11-04 18:36:19 -0600169 printf "%s\n" "$submodule_dir ($commits commits)" >> "$LOGFILE"
170 printf "\n" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700171 fi
Martin Rotheb80d8d2022-02-28 14:41:57 -0700172 ); then
173 version_ctrl_c
174 fi
Martin Rothbec11082015-11-03 21:01:53 -0700175}
176
Martin Rothfb190ed2016-10-01 20:13:43 -0600177find_areas() {
Martin Roth3ce67832017-11-04 18:36:19 -0600178 local directory="$1"
179 local filename="$2"
180 local skip="$3"
181 find "$directory" -name "$filename" | sed "s|/$filename||" | sed "s|/$directory||" | grep -v "$skip" | sort
Martin Rothfb190ed2016-10-01 20:13:43 -0600182}
183
184# Make sure things get cleaned up if ctl-c is pressed while the old version
185# is checked out and files are renamed. This can be a real mess to clean
186# up manually.
Martin Rothbec11082015-11-03 21:01:53 -0700187version_ctrl_c() {
Martin Rotheb80d8d2022-02-28 14:41:57 -0700188 printf "\n Cleaning up and exiting.\n" >&2
Martin Rothfb190ed2016-10-01 20:13:43 -0600189 find 'src' -name 'gnumakefile' \
190 -exec rename 's/gnumakefile/Makefile\.inc/' {} \;
191 git checkout origin/master > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700192 git submodule update --init --checkout > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700193 rm "$LOGFILE"
194 exit 1;
195}
196
Martin Rothfb190ed2016-10-01 20:13:43 -0600197# Calculate areas that have been added or removed based on file lists
198show_diff () {
199 local new
200 local old
Martin Rothbec11082015-11-03 21:01:53 -0700201
Patrick Georgi1916d682019-11-20 16:05:21 +0100202 new="$(comm -13 <(echo "$2") <(echo "$3"))"
203 old="$(comm -23 <(echo "$2") <(echo "$3"))"
204
205 # Allow running a postprocessor, given as 4th argument over the
206 # resulting diff, provide context if it's old or new data
207 if [ -n "$4" ]; then
208 new=$(echo "$new" | $4 new | sort)
209 old=$(echo "$old" | $4 old | sort)
210 fi
Martin Rotheb80d8d2022-02-28 14:41:57 -0700211 new="$(printf "%s" "$new" | sed 's/^/* /')"
212 old="$(printf "%s" "$old" | sed 's/^/* /')"
Patrick Georgi1916d682019-11-20 16:05:21 +0100213
Martin Rothfb190ed2016-10-01 20:13:43 -0600214 if [ -n "$new" ]; then
215 printf "Added %s $1:\n-------------------\n%s\n\n" \
216 "$(echo "$new" | wc -l)" "$new" >> "$LOGFILE"
217 fi
Martin Rothfb190ed2016-10-01 20:13:43 -0600218 if [ -n "$old" ]; then
219 printf "Removed %s $1:\n-------------------\n%s\n\n" \
220 "$(echo "$old" | wc -l)" "$old" >> "$LOGFILE"
221 fi
222}
223
Martin Roth3ce67832017-11-04 18:36:19 -0600224get_sloc () {
225 # Because cloc works on extensions, and .inc identifies as pascal,
Patrick Georgi436296b2019-11-20 17:15:13 +0100226 # while we use it both for Makefile.inc and some files that are
227 # really C, do three passes: everything but .inc files, all .inc files
228 # that aren't Makefiles, all Makefile.inc, then combine them.
Martin Roth3ce67832017-11-04 18:36:19 -0600229
Martin Rotheb80d8d2022-02-28 14:41:57 -0700230 local base
231 base=$(mktemp)
232 find src -name Makefile.inc > "${base}.mak"
Martin Roth3ce67832017-11-04 18:36:19 -0600233
Patrick Georgi436296b2019-11-20 17:15:13 +0100234 cloc --progress-rate=0 --quiet \
235 --script-lang="Bourne Shell",bash --exclude-ext=inc \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700236 --exclude-dir=vendorcode "--out=${base}" src
Patrick Georgi436296b2019-11-20 17:15:13 +0100237 cloc --progress-rate=0 --quiet \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700238 "--exclude-list-file=${base}.mak" --force-lang=c,inc \
239 --exclude-dir=vendorcode "--out=${base}.c" src
Patrick Georgi436296b2019-11-20 17:15:13 +0100240 cloc --progress-rate=0 --quiet \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700241 "--list-file=${base}.mak" --force-lang=make,inc \
242 --exclude-dir=vendorcode "--out=${base}.m" src
Patrick Georgi436296b2019-11-20 17:15:13 +0100243 cloc --progress-rate=0 --quiet --sum-reports \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700244 "${base}" "${base}.c" "${base}.m" --out "${base}.result"
Patrick Georgi436296b2019-11-20 17:15:13 +0100245
246 echo
Martin Rotheb80d8d2022-02-28 14:41:57 -0700247 cat "${base}.result.lang"
Patrick Georgi436296b2019-11-20 17:15:13 +0100248
Martin Rotheb80d8d2022-02-28 14:41:57 -0700249 rm -f "${base}"*
Martin Roth3ce67832017-11-04 18:36:19 -0600250}
251
Martin Rothfb190ed2016-10-01 20:13:43 -0600252# Start collecting data from the old and new revisions.
253# This is relatively disruptive to the tree, so trap on ctl-c so that
254# things can be put back to normal
255trap version_ctrl_c SIGINT
Martin Rothbec11082015-11-03 21:01:53 -0700256
257#check out old version and get information
Martin Rotheb80d8d2022-02-28 14:41:57 -0700258echo "Finding old submodule versions..." >&2
Martin Rothfb190ed2016-10-01 20:13:43 -0600259git checkout "$OLD_GIT_VERSION" > /dev/null 2>&1
Martin Rotheb80d8d2022-02-28 14:41:57 -0700260echo "Git version: $(git log --oneline -n 1)"
Martin Rothbec11082015-11-03 21:01:53 -0700261git submodule update --init --checkout > /dev/null 2>&1
Martin Roth3ce67832017-11-04 18:36:19 -0600262for module in $(git submodule --quiet foreach pwd); do
263 name="$(basename "$module" | sed 's/-/_/g')"
264 version="${name^^}_OLD_VERSION"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700265 declare "$version"="$(get_latest_commit_id "$module")"
Martin Roth3ce67832017-11-04 18:36:19 -0600266done
Martin Rothfb190ed2016-10-01 20:13:43 -0600267
Martin Rotheb80d8d2022-02-28 14:41:57 -0700268printf "Logging directories in the old tree\n" >&2
Martin Roth3ce67832017-11-04 18:36:19 -0600269mainboard_list_old=$(grep -h "^[[:space:]]*config\>[[:space:]]*\<BOARD_" src/mainboard/*/*/Kconfig.name 2>/dev/null | sed "s,^.*\<BOARD_\([A-Z0-9_]*\)\>.*$,\1," | sort)
270cpu_list_old=$(find_areas "src/cpu" "Kconfig" "intel/common")
271soc_list_old=$(find_areas "src/soc" "Makefile.inc" "intel/common\|amd/common\|romstage")
272northbridge_list_old=$(find_areas "src/northbridge" "Kconfig" "")
273sio_list_old=$(find_areas "src/superio" "Makefile.inc" "")
274southbridge_list_old=$(find_areas "src/southbridge" "Kconfig" "")
Martin Rothfb190ed2016-10-01 20:13:43 -0600275
Martin Rotheb80d8d2022-02-28 14:41:57 -0700276echo "Calculating old SLOC"
Martin Roth3ce67832017-11-04 18:36:19 -0600277OLD_SLOC=$(get_sloc)
Martin Rothbec11082015-11-03 21:01:53 -0700278
279#check out new version and get information
Martin Rotheb80d8d2022-02-28 14:41:57 -0700280printf -- "\nFinding new submodule versions...\n" >&2
Martin Rothfb190ed2016-10-01 20:13:43 -0600281git checkout "$NEW_GIT_VERSION" > /dev/null 2>&1
Martin Rotheb80d8d2022-02-28 14:41:57 -0700282echo "Git version: $(git log --oneline -n 1)"
Martin Rothbec11082015-11-03 21:01:53 -0700283git submodule update --init --checkout > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700284
Martin Roth3ce67832017-11-04 18:36:19 -0600285for module in $(git submodule --quiet foreach pwd); do
286 name="$(basename "$module" | sed 's/-/_/g')"
287 version="${name^^}_NEW_VERSION"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700288 declare "$version"="$(get_latest_commit_id "$module")"
Martin Roth3ce67832017-11-04 18:36:19 -0600289done
Martin Rothfb190ed2016-10-01 20:13:43 -0600290
Martin Rotheb80d8d2022-02-28 14:41:57 -0700291echo "Logging directories in the new tree." >&2
Martin Roth3ce67832017-11-04 18:36:19 -0600292mainboard_list_new=$(grep -h "^[[:space:]]*config\>[[:space:]]*\<BOARD_" src/mainboard/*/*/Kconfig.name 2>/dev/null | sed "s,^.*\<BOARD_\([A-Z0-9_]*\)\>.*$,\1," | sort)
293cpu_list_new=$(find_areas "src/cpu" "Kconfig" "intel/common")
294soc_list_new=$(find_areas "src/soc" "Makefile.inc" "intel/common\|amd/common\|romstage")
295northbridge_list_new=$(find_areas "src/northbridge" "Kconfig" "")
296sio_list_new=$(find_areas "src/superio" "Makefile.inc" "")
297southbridge_list_new=$(find_areas "src/southbridge" "Kconfig" "")
298
Martin Rothfb190ed2016-10-01 20:13:43 -0600299printf "Calculating new SLOC\n"
Martin Roth3ce67832017-11-04 18:36:19 -0600300NEW_SLOC=$(get_sloc)
Martin Rothbec11082015-11-03 21:01:53 -0700301
302git checkout origin/master > /dev/null 2>&1
303git submodule update --init --checkout > /dev/null 2>&1
Martin Rothbec11082015-11-03 21:01:53 -0700304trap "" SIGINT
Martin Rotheb80d8d2022-02-28 14:41:57 -0700305
Martin Rothfb190ed2016-10-01 20:13:43 -0600306# Done collecting data from the old and new versions
Martin Rothbec11082015-11-03 21:01:53 -0700307
Martin Rothfb190ed2016-10-01 20:13:43 -0600308# Start outputting to logfile
309echo "Generating release notes from version ${OLD_GIT_VERSION} to ${NEW_GIT_VERSION}"
310echo; echo "Main repo"
311echo "Main repo" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700312echo "------------------" >> "$LOGFILE"
Martin Rothfb190ed2016-10-01 20:13:43 -0600313log_versions "$(git log --pretty=%H \
314 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | tail -1)" \
315 "$(git log --pretty=%H \
316 "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | head -1 )"
317echo "" >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700318
Martin Roth3ce67832017-11-04 18:36:19 -0600319### SPECIFIC AREAS FOR RELEASE ###
Martin Rotheb80d8d2022-02-28 14:41:57 -0700320get_log_dedupe "Documentation" "Documentation README"
321
322get_log_dedupe "cleanup" "" "add missing\|fix typo\|clean up\|spelling\|Use tabs\|space [around\|before]\|code formatting\|commented code\|code cleanup\|capitalize\|[unnecessary\|unneeded\|trailing] whitespace\|checkpatch\|remove [unused\|dead\|unneeded\|duplicated\|not used]\|[transition away from\|get rid of\|don't use] device_t"
323
324get_log_dedupe "ACPI Changes" "" "ASL 2.0 syntax"
Martin Rothbec11082015-11-03 21:01:53 -0700325
Martin Roth3ce67832017-11-04 18:36:19 -0600326get_log_dedupe "Google Kahlee / AMD Gardenia" "src/mainboard/google/kahlee src/mainboard/amd/gardenia" "kahlee\|gardenia"
327get_log_dedupe "AMD Stoney Ridge" "src/soc/amd/stoneyridge" "stoney"
Martin Rothbec11082015-11-03 21:01:53 -0700328
Martin Rotheb80d8d2022-02-28 14:41:57 -0700329get_log_dedupe "Google Zork / AMD Mandolin / AMD Bilby" "src/mainboard/amd/mandolin src/mainboard/google/zork src/mainboard/amd/bilby" "mandolin\|zork\|bilby"
330get_log_dedupe "AMD Picasso" "src/soc/amd/picasso" "picasso"
331
332get_log_dedupe "Google Guybrush / AMD Majolica" "src/mainboard/google/guybrush src/mainboard/amd/majolica" "majolica\|guybrush"
333get_log_dedupe "AMD cezanne" "src/soc/amd/cezanne" "cezanne"
334
335get_log_dedupe "AMD chausie / Google Skyrim" "src/mainboard/amd/chausie src/mainboard/google/skyrim" "chausie\|skyrim"
336get_log_dedupe "AMD sabrina" "src/soc/amd/sabrina" "sabrina"
337
338get_log_dedupe "Google Brya / Intel adlrvp" "src/mainboard/intel/adlrvp src/mainboard/google/brya" "brya\|adlrvp"
339get_log_dedupe "Intel Alder Lake" "src/soc/intel/alderlake" "alderlake\|adl\|alder lake"
340
341get_log_dedupe "intel Elkhart Lake" "src/soc/intel/elkhartlake" "elkhartlake\|ehl\|elkhart lake"
342
343get_log_dedupe "Google Dedede" "src/mainboard/google/dedede" "dedede"
344get_log_dedupe "intel Jasper Lake" "src/soc/intel/jasperlake" "jasperlake\|jsl\|jasper lake"
345
346get_log_dedupe "Intel Tiger Lake" "src/soc/intel/tigerlake" "tigerlake\|tgl\|tiger lake"
347
348get_log_dedupe "Google Hatch" "src/mainboard/google/hatch" "hatch"
349get_log_dedupe "Intel Comet Lake" "src/soc/intel/cometlake" "cometlake\|cml\|comet lake"
350
Martin Roth3ce67832017-11-04 18:36:19 -0600351get_log_dedupe "Google Eve / Poppy / Fizz / Soraka / Nautilus / Intel KblRvp" "src/mainboard/google/eve src/mainboard/google/poppy src/mainboard/google/fizz src/mainboard/intel/kblrvp" "eve[ :]\|poppy\|fizz\|soraka\|nautilus\|kblrvp"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700352
353get_log_dedupe "Intel Kunimitsu / Google Chell / Lars / Glados" "src/mainboard/google/lars src/mainboard/google/chell src/mainboard/google/glados src/mainboard/intel/kunimitsu" "chell\|lars\|kunimitsu"
Martin Roth3ce67832017-11-04 18:36:19 -0600354get_log_dedupe "Purism SKL" "src/mainboard/purism/librem_skl" "librem13v2\|librem_skl"
355get_log_dedupe "Intel Skylake / Kabylake" "src/soc/intel/skylake" "skylake\|sky.lake\|kabylake\|kaby.lake"
Martin Rothbec11082015-11-03 21:01:53 -0700356
Martin Rotheb80d8d2022-02-28 14:41:57 -0700357get_log_dedupe "Intel Glkrvp / Google Octopus / Bip / Yorp" "src/mainboard/google/octopus src/mainboard/intel/glkrvp" "octopus\|glkrvp|\bip\|yorp"
358
Martin Roth3ce67832017-11-04 18:36:19 -0600359get_log_dedupe "Google Cyan / Intel Strago" "src/mainboard/google/cyan src/mainboard/intel/strago" "cyan\|strago"
360get_log_dedupe "Intel Braswell" "src/soc/intel/braswell" "braswell"
Martin Rothbec11082015-11-03 21:01:53 -0700361
Martin Roth3ce67832017-11-04 18:36:19 -0600362get_log_dedupe "Google Kevin / Gru / Bob / Scarlet / Nefario" "src/mainboard/google/gru" "kevin\|gru[^b]"
363get_log_dedupe "Rockchip rk3399" "src/soc/rockchip/rk3399" "rk3399"
Martin Rothbec11082015-11-03 21:01:53 -0700364
Martin Roth3ce67832017-11-04 18:36:19 -0600365get_log_dedupe "Google Reef / Pyro / Sand / Snappy / Nasher" "src/mainboard/google/reef" "reef\|pyro\|sand[ :]\|snappy\|nasher"
366#get_log_dedupe "Intel apollolake_rvp leafhill minnow3" "src/mainboard/intel/apollolake_rvp src/mainboard/intel/leafhill src/mainboard/intel/minnow3" "apollolake_rvp\|leafhill\|minnow3"
367get_log_dedupe "Siemens mc_apl1" "src/mainboard/siemens/mc_apl1" "mc_apl1"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700368get_log_dedupe "Intel Apollolake/ Geminilake" "src/soc/intel/apollolake" "apollolake\|apollo.lake\|geminilake\|gemini.lake\|apl\|glk"
Martin Rothbec11082015-11-03 21:01:53 -0700369
Martin Rotheb80d8d2022-02-28 14:41:57 -0700370get_log_dedupe "Google Zoombini / Intel cannonlake_rvp" "src/mainboard/google/zoombini src/mainboard/intel/cannonlake_rvp" "zoombini\|cannonlake_rvp"
Martin Roth3ce67832017-11-04 18:36:19 -0600371get_log_dedupe "Intel CannonLake" "src/soc/intel/cannonlake src/mainboard/intel/cannonlake_rvp" "cannonlake"
Martin Rothfb190ed2016-10-01 20:13:43 -0600372
Martin Rotheb80d8d2022-02-28 14:41:57 -0700373get_log_dedupe "Google Kuki" "src/mainboard/google/kukui" "kukui"
374get_log_dedupe "mediatek/mt8183" "src/soc/mediatek/mt8183" "mt8183"
375
376get_log_dedupe "Google Cheza" "src/mainboard/google/cheza" "cheza"
377get_log_dedupe "Qualcomm sdm845" "src/soc/qualcomm/sdm845" "sdm845"
378
379get_log_dedupe "Prodrive Hermes / Google Sarien / Intel coffeelake_rvp" "src/mainboard/intel/coffeelake_rvp src/mainboard/google/sarien src/mainboard/prodrive/hermes"
380get_log_dedupe "Intel Coffeelake" "soc/intel/coffeelake"
381
Martin Rotheb80d8d2022-02-28 14:41:57 -0700382get_log_dedupe "Cavium" "src/soc/cavium src/mainboard/cavium src/mainboard/opencellular/elgon "
383get_log_dedupe "Scaleway Tagada" "src/mainboard/scaleway/tagada" "tagada"
384
Martin Roth3ce67832017-11-04 18:36:19 -0600385get_log_dedupe "Intel Galileo" "src/mainboard/intel/galileo" "galileo"
386get_log_dedupe "Intel Quark" "src/soc/intel/quark" "quark"
Martin Rothfb190ed2016-10-01 20:13:43 -0600387
Martin Roth3ce67832017-11-04 18:36:19 -0600388get_log_dedupe "Intel Baytrail" "src/soc/intel/baytrail" "baytrail"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700389get_log_dedupe "Google Gale / Qualcomm QX ipq40xx" "src/mainboard/google/gale src/soc/qualcomm/ipq40xx" "gale\|ipq40"
390get_log_dedupe "Google Rotor / Marvell Mvmap2315" "src/soc/marvell/mvmap2315 src/mainboard/google/rotor" "marvell\|mvmap\|rotor"
Martin Rothfb190ed2016-10-01 20:13:43 -0600391
Martin Roth3ce67832017-11-04 18:36:19 -0600392get_log_dedupe "Gigabyte ga-g41m-es2l" "src/mainboard/gigabyte/ga-g41m-es2l" "es2l"
393get_log_dedupe "Intel x4x northbridge / LGA775" "src/northbridge/intel/x4x src/cpu/intel/socket_LGA775" "x4x\|lga775"
Martin Rothfb190ed2016-10-01 20:13:43 -0600394
Martin Rotheb80d8d2022-02-28 14:41:57 -0700395get_log_dedupe "Intel Haswell / Broadwell" "src/northbridge/haswell" "haswell"
396get_log_dedupe "Intel Lynxpoint" "src/southbridge/intel/lynxpoint" "lynxpoint"
397
Martin Roth3ce67832017-11-04 18:36:19 -0600398get_log_dedupe "Intel Sandybridge / Ivybridge" "src/southbridge/intel/bd82x6x src/southbridge/intel/fsp_bd82x6x src/northbridge/intel/sandybridge src/northbridge/intel/fsp_sandybridge src/cpu/intel/fsp_model_206ax src/cpu/intel/model_206ax" "sandybridge\|ivybridge\|bd82x6x"
Martin Rothfb190ed2016-10-01 20:13:43 -0600399
Martin Rotheb80d8d2022-02-28 14:41:57 -0700400get_log_dedupe "Google Herbrine" "src/mainboard/google/herobrine" "herobrine"
401get_log_dedupe "Qualcomm SC7280" "src/soc/qualcomm/sc2780" "sc2780"
402
403get_log_dedupe "Google Corsola" "src/mainboard/google/corsola" "corsola"
404get_log_dedupe "Mediatek MT8186" "src/soc/mediatek/mt8186" "mt8186"
405
Martin Roth3ce67832017-11-04 18:36:19 -0600406get_log_dedupe "Intel Common" "src/soc/intel/common src/southbridge/intel/common src/northbridge/intel/common" ""
407get_log_dedupe "Amd Common" "src/soc/amd/common src/southbridge/amd/common" ""
408
Patrick Georgi3b34ef22019-06-30 11:41:51 +0200409get_log_dedupe "Nvidia" "src/southbridge/nvidia" ""
410get_log_dedupe "Via" "src/northbridge/via src/southbridge/via" ""
411get_log_dedupe "Broadcom" "src/southbridge/broadcom" ""
412get_log_dedupe "Qualcomm" "src/soc/qualcomm" ""
Martin Rotheb80d8d2022-02-28 14:41:57 -0700413get_log_dedupe "Mediatek" "src/soc/mediatek" ""
Patrick Georgi3b34ef22019-06-30 11:41:51 +0200414
Martin Roth3ce67832017-11-04 18:36:19 -0600415get_log_dedupe "Intel vendorcode / FSP" "src/drivers/intel/fsp* src/vendorcode/intel" ""
Martin Rotheb80d8d2022-02-28 14:41:57 -0700416get_log_dedupe "AMD vendorcode / AGESA / PI" "src/vendorcode/amd" "agesa\|binarypi"
Martin Roth3ce67832017-11-04 18:36:19 -0600417get_log_dedupe "Google vendorcode" "src/vendorcode/google"
Martin Rotheb80d8d2022-02-28 14:41:57 -0700418get_log_dedupe "Cavium vendorcode" "src/vendorcode/cavium"
Martin Roth3ce67832017-11-04 18:36:19 -0600419
Martin Rotheb80d8d2022-02-28 14:41:57 -0700420get_log_dedupe "Security" "src/drivers/i2c/tpm src/security" "tpm"
Martin Roth3ce67832017-11-04 18:36:19 -0600421get_log_dedupe "Vboot" "src/vboot" "vboot"
422
423
424### GENERAL AREAS FOR RELEASE ###
425# shellcheck disable=SC2013
426{
Martin Rotheb80d8d2022-02-28 14:41:57 -0700427
428get_log_dedupe "X86 intel" \
429 "src/cpu/intel src/soc/intel src/northbridge/intel \
430 src/southbridge/intel src/include/intel src/drivers/intel"
431
432get_log_dedupe "X86 AMD" \
433 "src/cpu/amd src/northbridge/amd src/southbridge/amd src/include/amd src/soc/amd" \
434 "agesa\|binarypi\|binary.pi"
435
436get_log_dedupe "X86 common" \
437 "src/arch/x86 src/cpu/x86 src/include/x86 src/include/pc80"
438
Martin Roth3ce67832017-11-04 18:36:19 -0600439get_log_dedupe "ARM" \
440 "$(for codedir in $(grep -rl "_ARM" --include=Kconfig | \
441 grep -v 'src/mainboard\|payloads/\|drivers/\|vendorcode/\|console' ); \
442 do dirname "$codedir"; done | grep -v '^src$')"
443
444get_log_dedupe "RISC-V" \
445 "$(for codedir in $(grep -rl "_RISCV" --include=Kconfig | grep -v 'payloads/\|drivers/\|vendorcode/\|console' ); do dirname "$codedir"; done | grep -v '^src$')" \
Martin Rotheb80d8d2022-02-28 14:41:57 -0700446 "riscv\|risc-v\|lowrisc\|sifive"
Martin Roth3ce67832017-11-04 18:36:19 -0600447}
448
Martin Rotheb80d8d2022-02-28 14:41:57 -0700449get_log_dedupe "Google Mainboards" "src/mainboard/google"
450get_log_dedupe "Intel Mainboards" "src/mainboard/intel"
451get_log_dedupe "AMD Mainboards" "src/mainboard/amd"
Martin Roth3ce67832017-11-04 18:36:19 -0600452get_log_dedupe "Mainboards" "src/mainboard/"
453
454# Next, print all the rest of the specific areas
455get_log_dedupe "ACPI" "src/acpi/"
456get_log_dedupe "Console" "src/console src/include/console"
457get_log_dedupe "SuperIO" "src/superio src/include/superio"
458get_log_dedupe "EC" "src/ec"
459get_log_dedupe "Drivers" "src/drivers"
460get_log_dedupe "Devices" "src/device src/include/device"
461
462# 5th, print the generic areas - This goes late so that the specific
463# area changes will catch any commits in these areas first.
464get_log_dedupe "Toolchain" "util/crossgcc"
465get_log_dedupe "cbfstool" "util/cbfstool"
466get_log_dedupe "Lint tools" "util/lint"
467get_log_dedupe "Lib" "src/lib"
468get_log_dedupe "Commonlib" "src/commonlib"
469get_log_dedupe "Include" "src/include"
470get_log_dedupe "Utilities" "util"
471get_log_dedupe "Payloads" "payloads"
472get_log_dedupe "Vendorcode" "src/vendorcode"
Martin Roth3ce67832017-11-04 18:36:19 -0600473
474# Then look at areas that are usually outside the mainboards and architectures
475get_log_dedupe "Build system" \
476 "Makefile Makefile.inc toolchain.inc src/Kconfig src/cpu/Makefile.inc"
477
478get_log_dedupe "Submodules" "3rdparty util/nvidia/cbootimage"
Patrick Georgi3b34ef22019-06-30 11:41:51 +0200479
480get_log_dedupe "Maintainers" "MAINTAINERS" ""
481
Martin Roth3ce67832017-11-04 18:36:19 -0600482# Finally, get anything that was missed above
483get_log_dedupe "MISC" "."
484
Patrick Georgi1916d682019-11-20 16:05:21 +0100485# Replace VENDOR_DEVICE from stdin with their nice names on stdout
486real_mainboard_names() {
487 local tree_version=$1 # "old" or "new"
488 local git_version_var=${tree_version^^}_GIT_VERSION
489 local git_version=${!git_version_var}
490 local line
Martin Rotheb80d8d2022-02-28 14:41:57 -0700491 local file
492 local vendor
Patrick Georgi1916d682019-11-20 16:05:21 +0100493
Martin Rotheb80d8d2022-02-28 14:41:57 -0700494 while read -r line; do
495 file="$(git grep -l "^[[:space:]]*config\>[[:space:]]*\<BOARD_${line}\$" "${git_version}" -- src/mainboard/\*/\*/Kconfig.name | sed "s,^${git_version}:,,")"
Patrick Georgi1916d682019-11-20 16:05:21 +0100496 if [ -z "$file" ]; then
497 echo "This shouldn't happen: couldn't find Kconfig for $line"
498 exit 1
499 fi
Martin Rotheb80d8d2022-02-28 14:41:57 -0700500 vendor="$(git grep \" "${git_version}" -- "$(echo "${file}" | cut -d/ -f1-3,5)" | cut -d\" -f2)"
501 git grep -h -A1 "^[[:space:]]*config\>[[:space:]]*\<BOARD_${line}\$" "${git_version}" -- "${file}" | grep \" |cut -d\" -f2 |sed "s,^,${vendor} ,"
Patrick Georgi1916d682019-11-20 16:05:21 +0100502 done
503}
504
Martin Roth3ce67832017-11-04 18:36:19 -0600505# Show areas that have been added or removed
Patrick Georgi1916d682019-11-20 16:05:21 +0100506show_diff "mainboards" "$mainboard_list_old" "$mainboard_list_new" real_mainboard_names
Martin Roth3ce67832017-11-04 18:36:19 -0600507show_diff "processors" "$cpu_list_old" "$cpu_list_new"
508show_diff "socs" "$soc_list_old" "$soc_list_new"
509show_diff "northbridges" "$northbridge_list_old" "$northbridge_list_new"
510show_diff "southbridges" "$southbridge_list_old" "$southbridge_list_new"
511show_diff "sios" "$sio_list_old" "$sio_list_new"
512
513# Log submodules
514printf "Submodules\n----------\n" >> "$LOGFILE"
515for module in $(git submodule --quiet foreach pwd); do
516 name=$(basename "$module")
Martin Rotheb80d8d2022-02-28 14:41:57 -0700517 module="$(realpath "${module}")"
518 workingdir="$(realpath "${PWD}")"
Martin Roth3ce67832017-11-04 18:36:19 -0600519 # shellcheck disable=SC2001
Martin Rotheb80d8d2022-02-28 14:41:57 -0700520 path=${module#"$workingdir"}
Martin Roth3ce67832017-11-04 18:36:19 -0600521 old_version=$(echo "${name^^}_OLD_VERSION" | sed 's/-/_/g')
522 new_version=$(echo "${name^^}_NEW_VERSION" | sed 's/-/_/g')
Martin Rotheb80d8d2022-02-28 14:41:57 -0700523 get_log_submodule "${!old_version}" "${!new_version}" "${path}"
Martin Roth3ce67832017-11-04 18:36:19 -0600524done
Martin Rothbec11082015-11-03 21:01:53 -0700525
Martin Rothfb190ed2016-10-01 20:13:43 -0600526printf "\nrepo statistics\n-------------------\n" >> "$LOGFILE"
527before_names="$(mktemp "OLDNAMES.XXXX")"
528after_names="$(mktemp "NEWNAMES.XXXX")"
529NEW_AUTHORS=$(git log --pretty=%an "${OLD_GIT_VERSION}" 2>/dev/null | sort | \
530 uniq > "$before_names" && \
531 git log --pretty=%an "${NEW_GIT_VERSION}" 2>/dev/null | \
532 sort | uniq > "$after_names" && \
533 grep -Fxv -c -f "$before_names" "$after_names")
Patrick Georgid653e492019-11-20 16:49:41 +0100534NEW_AUTHOR_LIST=$( grep -Fxv -f "$before_names" "$after_names")
535rm -f "$before_names" "$after_names"
Martin Rothfb190ed2016-10-01 20:13:43 -0600536{
537 printf -- "- Total commits: %s\n" "$TOTAL_COMMITS"
538 printf -- "- Total authors: %s\n" \
539 "$(git log "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | \
540 grep -e '^Author:' | sed 's/.*Author: //' | sed 's/ <.*.>//' | \
541 sort | uniq | wc -l)"
542 printf -- "- New authors: %s\n\nNew Authors:\n%s\n" "$NEW_AUTHORS" \
543 "$NEW_AUTHOR_LIST"
544} >> "$LOGFILE"
Martin Rothbec11082015-11-03 21:01:53 -0700545
Martin Rothfb190ed2016-10-01 20:13:43 -0600546printf "Getting developer list\n"
547printf "\n%-40s: %5s\n" "Developer" "Commits" >> "$LOGFILE"
548git log "${OLD_GIT_VERSION}..${NEW_GIT_VERSION}" 2>/dev/null | grep '^Author: ' | \
549 sed 's|Author: ||' | sed 's|\s<.*||' | sort | uniq | \
550 while read -r line; do
551 printf "%-40s: %5s %5s\n" "$line" \
552 "$(git log "${OLD_GIT_VERSION}" 2>/dev/null | \
553 grep -c "^Author: ${line} <")" \
554 "$(git log "${NEW_GIT_VERSION}" 2>/dev/null | \
555 grep -c "^Author: ${line} <")" >> "$LOGFILE";
556 done
Martin Rothbec11082015-11-03 21:01:53 -0700557
558printf "\nOld SLOC (%s)\n%s" "$NOW" "$OLD_SLOC" >> "$LOGFILE"
559printf "\nNew SLOC (%s)\n%s" "$NOW" "$NEW_SLOC" >> "$LOGFILE"
560
561# Add the collected data to the top of the existing logfile for parsing
562if [ -n "$UPDATE_MAIN_LOGFILE" ]; then
563 tmpfile="$(mktemp "LOGFILE.XXXX")"
564 grep -Fxv -f "$MAIN_LOGFILE" "$LOGFILE" > "$tmpfile"
565 printf "\n\n" >> "$tmpfile"
566 cat "$MAIN_LOGFILE" >> "$tmpfile"
567 mv "$tmpfile" "$MAIN_LOGFILE"
568 rm -f "$LOGFILE"
569fi
Martin Rothfb190ed2016-10-01 20:13:43 -0600570
571printf "Done.\n"